/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
#ifndef _JS_FP_CLASS_H_
#define _JS_FP_CLASS_H_

#include "js-types.h"

/* Classes */
class JSFpClass {
    public:
        typedef union {
            double  d;
            uint32_t u[ 2 ];
        } duval_t;

    public:
	static const uint32_t	HI32_SIGNBIT = 0x80000000;
	static const uint32_t	HI32_EXPMASK = 0x7ff00000;
	static const uint32_t	HI32_MANTMASK = 0x000fffff;

    public:
	static uint32_t	HI32(double d) {
            duval_t v;

            v.d = d;
#ifdef LBFIRST
	    return v.u[1];
#else
	    return v.u[0];
#endif
	}
	static uint32_t	LO32(double d) {
            duval_t v;

            v.d = d;
#ifdef LBFIRST
	    return v.u[0];
#else
	    return v.u[1];
#endif
	}
	static int finite(double d) {
	    return ((HI32(d) & HI32_EXPMASK) != HI32_EXPMASK);
	}
	static int _isnan(double d) {
	    return (
		(HI32(d) & HI32_EXPMASK) == HI32_EXPMASK
		&& (LO32(d) || (HI32(d) & HI32_MANTMASK))
	    ) ;
	}
	static	int isinfinite(double d) {
	    return  ((HI32(d) & ~HI32_SIGNBIT) == HI32_EXPMASK && LO32(d) == 0);
	}
	static	int isnegzero(double d) {
	    return  (HI32(d) == HI32_SIGNBIT && LO32(d) == 0);
	}
} ;

/* Macros */
#define	finite(d)	JSFpClass::finite(d)
#ifndef linux
# define isnan(d)	JSFpClass::_isnan(d)
#endif

#endif /* _JS_FP_CLASS_H_ */

